"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isNodeOverlapped = void 0;
function isNodeOverlapped(node, rect) {
    var centerX = (rect.left + rect.right) / 2;
    var centerY = (rect.top + rect.bottom) / 2;
    var topElement = document.elementFromPoint(centerX, centerY);
    return !node.isSameNode(topElement) && !node.contains(topElement);
}
exports.isNodeOverlapped = isNodeOverlapped;
//# sourceMappingURL=node.js.map