(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define("KontentSmartLink", [], factory);
	else if(typeof exports === 'object')
		exports["KontentSmartLink"] = factory();
	else
		root["KontentSmartLink"] = factory();
})(window, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, { enumerable: true, get: getter });
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 			Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 		}
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// create a fake namespace object
/******/ 	// mode & 1: value is a module id, require it
/******/ 	// mode & 2: merge all properties of value into the ns
/******/ 	// mode & 4: return value when already ns object
/******/ 	// mode & 8|1: behave like require
/******/ 	__webpack_require__.t = function(value, mode) {
/******/ 		if(mode & 1) value = __webpack_require__(value);
/******/ 		if(mode & 8) return value;
/******/ 		if((mode & 4) && typeof value === 'object' && value && value.__esModule) return value;
/******/ 		var ns = Object.create(null);
/******/ 		__webpack_require__.r(ns);
/******/ 		Object.defineProperty(ns, 'default', { enumerable: true, value: value });
/******/ 		if(mode & 2 && typeof value != 'string') for(var key in value) __webpack_require__.d(ns, key, function(key) { return value[key]; }.bind(null, key));
/******/ 		return ns;
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = "./src/index.ts");
/******/ })
/************************************************************************/
/******/ ({

/***/ "./src/index.ts":
/*!**********************!*\
  !*** ./src/index.ts ***!
  \**********************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var plugin_1 = __webpack_require__(/*! ./plugin */ "./src/plugin.ts");
Object.defineProperty(exports, "default", { enumerable: true, get: function () { return plugin_1.default; } });


/***/ }),

/***/ "./src/lib/EventManager.ts":
/*!*********************************!*\
  !*** ./src/lib/EventManager.ts ***!
  \*********************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
exports.EventManager = void 0;
var EventManager = /** @class */ (function () {
    function EventManager() {
        var _this = this;
        this.listeners = new Map();
        this.on = function (event, listener) {
            var _a, _b;
            var newListeners = (_b = (_a = _this.listeners.get(event)) === null || _a === void 0 ? void 0 : _a.add(listener)) !== null && _b !== void 0 ? _b : new Set([listener]);
            _this.listeners.set(event, newListeners);
        };
        this.off = function (event, listener) {
            var _a;
            (_a = _this.listeners.get(event)) === null || _a === void 0 ? void 0 : _a.delete(listener);
        };
        this.emit = function (event, data) {
            var listeners = _this.listeners.get(event);
            if (listeners && listeners.size > 0) {
                listeners.forEach(function (callback) {
                    callback(data);
                });
            }
        };
        this.removeAllListeners = function () {
            _this.listeners = new Map();
        };
    }
    return EventManager;
}());
exports.EventManager = EventManager;


/***/ }),

/***/ "./src/lib/HighlightRenderer.ts":
/*!**************************************!*\
  !*** ./src/lib/HighlightRenderer.ts ***!
  \**************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HighlightRenderer = exports.HighlighterElementTag = exports.HighlighterViewTag = void 0;
var node_1 = __webpack_require__(/*! ../utils/node */ "./src/utils/node.ts");
exports.HighlighterViewTag = 'KONTENT-SMART-LINK-OVERLAY';
exports.HighlighterElementTag = 'KONTENT-SMART-LINK-ELEMENT';
var HighlightRenderer = /** @class */ (function () {
    function HighlightRenderer() {
        var _this = this;
        this.destroy = function () {
            var _a, _b;
            _this.clear();
            (_b = (_a = _this.view) === null || _a === void 0 ? void 0 : _a.parentElement) === null || _b === void 0 ? void 0 : _b.removeChild(_this.view);
        };
        this.selectNode = function (node) {
            var highlight = _this.highlightByNode.get(node);
            if (highlight) {
                node.style.cursor = 'pointer';
                highlight.classList.add('selected');
            }
        };
        this.deselectNode = function (node) {
            var highlight = _this.highlightByNode.get(node);
            if (highlight) {
                node.style.removeProperty('cursor');
                highlight.classList.remove('selected');
            }
        };
        this.render = function (nodes) {
            var e_1, _a, e_2, _b;
            var _c;
            if (nodes.size === 0) {
                _this.clear();
            }
            else {
                var newHighlightByNode = new Map();
                try {
                    for (var nodes_1 = __values(nodes), nodes_1_1 = nodes_1.next(); !nodes_1_1.done; nodes_1_1 = nodes_1.next()) {
                        var node = nodes_1_1.value;
                        var rect = node.getBoundingClientRect();
                        var overlapped = node_1.isNodeOverlapped(node, rect);
                        var flat = rect.height === 0 || rect.width === 0;
                        if (!overlapped && !flat) {
                            var highlight = (_c = _this.highlightByNode.get(node)) !== null && _c !== void 0 ? _c : _this.createHighlightForNode();
                            highlight.style.top = rect.top + window.pageYOffset + "px";
                            highlight.style.left = rect.left + window.pageXOffset + "px";
                            highlight.style.width = rect.width + "px";
                            highlight.style.height = rect.height + "px";
                            newHighlightByNode.set(node, highlight);
                            _this.highlightByNode.delete(node);
                        }
                    }
                }
                catch (e_1_1) { e_1 = { error: e_1_1 }; }
                finally {
                    try {
                        if (nodes_1_1 && !nodes_1_1.done && (_a = nodes_1.return)) _a.call(nodes_1);
                    }
                    finally { if (e_1) throw e_1.error; }
                }
                try {
                    for (var _d = __values(_this.highlightByNode.entries()), _e = _d.next(); !_e.done; _e = _d.next()) {
                        var _f = __read(_e.value, 2), node = _f[0], highlight = _f[1];
                        highlight.remove();
                        _this.highlightByNode.delete(node);
                    }
                }
                catch (e_2_1) { e_2 = { error: e_2_1 }; }
                finally {
                    try {
                        if (_e && !_e.done && (_b = _d.return)) _b.call(_d);
                    }
                    finally { if (e_2) throw e_2.error; }
                }
                _this.highlightByNode = newHighlightByNode;
            }
        };
        this.clear = function () {
            _this.view.innerHTML = '';
            _this.highlightByNode = new Map();
        };
        this.createHighlightForNode = function () {
            var highlight = document.createElement(exports.HighlighterElementTag);
            _this.view.appendChild(highlight);
            return highlight;
        };
        this.highlightByNode = new Map();
        this.view = HighlightRenderer.createView();
    }
    HighlightRenderer.createView = function () {
        var view = document.createElement(exports.HighlighterViewTag);
        window.document.body.appendChild(view);
        return view;
    };
    return HighlightRenderer;
}());
exports.HighlightRenderer = HighlightRenderer;


/***/ }),

/***/ "./src/lib/IFrameCommunicator.ts":
/*!***************************************!*\
  !*** ./src/lib/IFrameCommunicator.ts ***!
  \***************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
exports.IFrameCommunicator = exports.IFrameMessageType = void 0;
var iframe_1 = __webpack_require__(/*! ../utils/iframe */ "./src/utils/iframe.ts");
var EventManager_1 = __webpack_require__(/*! ./EventManager */ "./src/lib/EventManager.ts");
var IFrameMessageType;
(function (IFrameMessageType) {
    IFrameMessageType["Initialized"] = "kontent:initialized";
    IFrameMessageType["ElementClicked"] = "kontent:element:click";
    IFrameMessageType["HighlightsStatus"] = "kontent:highlights:status";
})(IFrameMessageType = exports.IFrameMessageType || (exports.IFrameMessageType = {}));
var IFrameCommunicator = /** @class */ (function () {
    function IFrameCommunicator() {
        var _this = this;
        this.addMessageListener = function (type, listener) {
            _this.events.on(type, listener);
        };
        this.removeMessageListener = function (type, listener) {
            _this.events.off(type, listener);
        };
        this.sendMessage = function (type, data) {
            if (!iframe_1.isInsideIFrame()) {
                console.error("Warning: can't send an iframe message, because the application is not hosted in an iframe");
                return;
            }
            var message = { type: type, data: data };
            window.parent.postMessage(message, '*');
        };
        this.onMessage = function (event) {
            if (!event.data)
                return;
            var message = event.data;
            _this.events.emit(message.type, message.data);
        };
        this.events = new EventManager_1.EventManager();
        window.addEventListener('message', this.onMessage, true);
    }
    IFrameCommunicator.prototype.destroy = function () {
        this.events.removeAllListeners();
        window.removeEventListener('message', this.onMessage, true);
    };
    return IFrameCommunicator;
}());
exports.IFrameCommunicator = IFrameCommunicator;


/***/ }),

/***/ "./src/lib/NodeSmartLinkProvider.ts":
/*!******************************************!*\
  !*** ./src/lib/NodeSmartLinkProvider.ts ***!
  \******************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.NodeSmartLinkProvider = exports.NodeSmartLinkProviderEventType = exports.NodeVisibilityThreshold = void 0;
var dataAttributes_1 = __webpack_require__(/*! ../utils/dataAttributes */ "./src/utils/dataAttributes.ts");
var EventManager_1 = __webpack_require__(/*! ./EventManager */ "./src/lib/EventManager.ts");
var HighlightRenderer_1 = __webpack_require__(/*! ./HighlightRenderer */ "./src/lib/HighlightRenderer.ts");
exports.NodeVisibilityThreshold = 0.5;
var NodeSmartLinkProviderEventType;
(function (NodeSmartLinkProviderEventType) {
    NodeSmartLinkProviderEventType["ElementClicked"] = "kontent:element:click";
})(NodeSmartLinkProviderEventType = exports.NodeSmartLinkProviderEventType || (exports.NodeSmartLinkProviderEventType = {}));
var NodeSmartLinkProvider = /** @class */ (function () {
    function NodeSmartLinkProvider() {
        var _this = this;
        this.enabled = false;
        this.renderingTimeoutId = 0;
        this.observedElements = new Set();
        this.visibleElements = new Set();
        this.destroy = function () {
            _this.disable();
            _this.renderer.destroy();
        };
        this.addEventListener = function (type, listener) {
            _this.events.on(type, listener);
        };
        this.removeEventListener = function (type, listener) {
            _this.events.off(type, listener);
        };
        this.enable = function () {
            if (_this.enabled)
                return;
            _this.startRenderingInterval();
            _this.listenToGlobalEvents();
            _this.observeDomMutations();
            _this.enabled = true;
        };
        this.disable = function () {
            if (!_this.enabled)
                return;
            _this.stopRenderingInterval();
            _this.unlistenToGlobalEvents();
            _this.disconnectObservers();
            _this.renderer.clear();
            _this.enabled = false;
        };
        this.highlightVisibleElements = function () {
            requestAnimationFrame(function () {
                _this.renderer.render(_this.visibleElements);
            });
        };
        /**
         * Start an interval rendering (1s) using `setTimeout`. This helps to adjust highlights position in case of CSS
         * animations, DOM attribute animations, etc. for better user experience since the NodeSmartLinkProvider currently
         * can't detect those changes of element position.
         */
        this.startRenderingInterval = function () {
            _this.highlightVisibleElements();
            _this.renderingTimeoutId = setTimeout(_this.startRenderingInterval, 1000);
        };
        this.stopRenderingInterval = function () {
            if (_this.renderingTimeoutId) {
                clearTimeout(_this.renderingTimeoutId);
                _this.renderingTimeoutId = 0;
            }
        };
        this.listenToGlobalEvents = function () {
            window.addEventListener('scroll', _this.highlightVisibleElements, { capture: true });
            window.addEventListener('resize', _this.highlightVisibleElements, { passive: true });
            window.addEventListener('click', _this.onElementClick, { capture: true });
        };
        this.unlistenToGlobalEvents = function () {
            window.removeEventListener('scroll', _this.highlightVisibleElements, { capture: true });
            window.removeEventListener('resize', _this.highlightVisibleElements);
            window.removeEventListener('click', _this.onElementClick, { capture: true });
        };
        this.observeDomMutations = function () {
            if (_this.enabled)
                return;
            document.querySelectorAll("*[" + dataAttributes_1.DataAttribute.ElementCodename + "]").forEach(function (element) {
                if (element instanceof HTMLElement) {
                    _this.observeElementVisibility(element);
                }
            });
            _this.mutationObserver.observe(window.document.body, {
                childList: true,
                subtree: true,
            });
        };
        this.disconnectObservers = function () {
            _this.mutationObserver.disconnect();
            _this.intersectionObserver.disconnect();
            _this.observedElements.forEach(function (element) {
                _this.unobserveElementVisibility(element);
            });
            _this.observedElements = new Set();
            _this.visibleElements = new Set();
        };
        this.observeElementVisibility = function (element) {
            if (_this.observedElements.has(element))
                return;
            _this.intersectionObserver.observe(element);
            _this.observedElements.add(element);
            element.addEventListener('mousemove', _this.onElementMouseEnter);
            element.addEventListener('mouseleave', _this.onElementMouseLeave);
        };
        this.unobserveElementVisibility = function (element) {
            if (!_this.observedElements.has(element))
                return;
            _this.intersectionObserver.unobserve(element);
            _this.observedElements.delete(element);
            _this.visibleElements.delete(element);
            element.removeEventListener('mousemove', _this.onElementMouseEnter);
            element.removeEventListener('mouseleave', _this.onElementMouseLeave);
        };
        this.onDomMutation = function (mutations) {
            var e_1, _a, e_2, _b, e_3, _c, e_4, _d, e_5, _e;
            var attrName = dataAttributes_1.dataToDatasetAttributeName(dataAttributes_1.DataAttribute.ElementCodename);
            var relevantMutations = mutations.filter(function (mutation) {
                return (mutation.target instanceof Element &&
                    ![HighlightRenderer_1.HighlighterElementTag, HighlightRenderer_1.HighlighterViewTag].includes(mutation.target.tagName) &&
                    mutation.type === 'childList');
            });
            try {
                for (var relevantMutations_1 = __values(relevantMutations), relevantMutations_1_1 = relevantMutations_1.next(); !relevantMutations_1_1.done; relevantMutations_1_1 = relevantMutations_1.next()) {
                    var mutation = relevantMutations_1_1.value;
                    try {
                        for (var _f = (e_2 = void 0, __values(mutation.addedNodes)), _g = _f.next(); !_g.done; _g = _f.next()) {
                            var node = _g.value;
                            if (!(node instanceof HTMLElement))
                                continue;
                            if (node.dataset[attrName]) {
                                _this.observeElementVisibility(node);
                            }
                            try {
                                for (var _h = (e_3 = void 0, __values(node.querySelectorAll("*[" + dataAttributes_1.DataAttribute.ElementCodename + "]"))), _j = _h.next(); !_j.done; _j = _h.next()) {
                                    var element = _j.value;
                                    if (!(element instanceof HTMLElement))
                                        continue;
                                    _this.observeElementVisibility(element);
                                }
                            }
                            catch (e_3_1) { e_3 = { error: e_3_1 }; }
                            finally {
                                try {
                                    if (_j && !_j.done && (_c = _h.return)) _c.call(_h);
                                }
                                finally { if (e_3) throw e_3.error; }
                            }
                        }
                    }
                    catch (e_2_1) { e_2 = { error: e_2_1 }; }
                    finally {
                        try {
                            if (_g && !_g.done && (_b = _f.return)) _b.call(_f);
                        }
                        finally { if (e_2) throw e_2.error; }
                    }
                    try {
                        for (var _k = (e_4 = void 0, __values(mutation.removedNodes)), _l = _k.next(); !_l.done; _l = _k.next()) {
                            var node = _l.value;
                            if (!(node instanceof HTMLElement))
                                continue;
                            if (node.dataset[attrName]) {
                                _this.unobserveElementVisibility(node);
                            }
                            try {
                                for (var _m = (e_5 = void 0, __values(node.querySelectorAll("*[" + dataAttributes_1.DataAttribute.ElementCodename + "]"))), _o = _m.next(); !_o.done; _o = _m.next()) {
                                    var element = _o.value;
                                    if (!(element instanceof HTMLElement))
                                        continue;
                                    _this.unobserveElementVisibility(element);
                                }
                            }
                            catch (e_5_1) { e_5 = { error: e_5_1 }; }
                            finally {
                                try {
                                    if (_o && !_o.done && (_e = _m.return)) _e.call(_m);
                                }
                                finally { if (e_5) throw e_5.error; }
                            }
                        }
                    }
                    catch (e_4_1) { e_4 = { error: e_4_1 }; }
                    finally {
                        try {
                            if (_l && !_l.done && (_d = _k.return)) _d.call(_k);
                        }
                        finally { if (e_4) throw e_4.error; }
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (relevantMutations_1_1 && !relevantMutations_1_1.done && (_a = relevantMutations_1.return)) _a.call(relevantMutations_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
            if (relevantMutations.length > 0) {
                _this.highlightVisibleElements();
            }
        };
        this.onElementVisibilityChange = function (entries) {
            var e_6, _a;
            var filteredEntries = entries.filter(function (entry) { return entry.target instanceof HTMLElement; });
            try {
                for (var filteredEntries_1 = __values(filteredEntries), filteredEntries_1_1 = filteredEntries_1.next(); !filteredEntries_1_1.done; filteredEntries_1_1 = filteredEntries_1.next()) {
                    var entry = filteredEntries_1_1.value;
                    var target = entry.target;
                    if (entry.isIntersecting && entry.intersectionRatio >= exports.NodeVisibilityThreshold) {
                        _this.visibleElements.add(target);
                    }
                    else {
                        _this.visibleElements.delete(target);
                    }
                }
            }
            catch (e_6_1) { e_6 = { error: e_6_1 }; }
            finally {
                try {
                    if (filteredEntries_1_1 && !filteredEntries_1_1.done && (_a = filteredEntries_1.return)) _a.call(filteredEntries_1);
                }
                finally { if (e_6) throw e_6.error; }
            }
            if (filteredEntries.length > 0) {
                _this.highlightVisibleElements();
            }
        };
        this.onElementClick = function (event) {
            var attributes = dataAttributes_1.getDataAttributesFromEventPath(event);
            if (attributes.has(dataAttributes_1.DataAttribute.ElementCodename)) {
                event.preventDefault();
                _this.events.emit(NodeSmartLinkProviderEventType.ElementClicked, {
                    projectId: attributes.get(dataAttributes_1.DataAttribute.ProjectId),
                    languageCodename: attributes.get(dataAttributes_1.DataAttribute.LanguageCodename),
                    itemId: attributes.get(dataAttributes_1.DataAttribute.ItemId),
                    elementCodename: attributes.get(dataAttributes_1.DataAttribute.ElementCodename),
                });
            }
        };
        this.onElementMouseEnter = function (event) {
            var node = event.currentTarget;
            _this.renderer.selectNode(node);
        };
        this.onElementMouseLeave = function (event) {
            var node = event.currentTarget;
            _this.renderer.deselectNode(node);
        };
        this.mutationObserver = new MutationObserver(this.onDomMutation);
        this.intersectionObserver = new IntersectionObserver(this.onElementVisibilityChange, {
            threshold: [exports.NodeVisibilityThreshold],
        });
        this.events = new EventManager_1.EventManager();
        this.renderer = new HighlightRenderer_1.HighlightRenderer();
    }
    return NodeSmartLinkProvider;
}());
exports.NodeSmartLinkProvider = NodeSmartLinkProvider;


/***/ }),

/***/ "./src/plugin.ts":
/*!***********************!*\
  !*** ./src/plugin.ts ***!
  \***********************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var iframe_1 = __webpack_require__(/*! ./utils/iframe */ "./src/utils/iframe.ts");
var link_1 = __webpack_require__(/*! ./utils/link */ "./src/utils/link.ts");
var IFrameCommunicator_1 = __webpack_require__(/*! ./lib/IFrameCommunicator */ "./src/lib/IFrameCommunicator.ts");
var NodeSmartLinkProvider_1 = __webpack_require__(/*! ./lib/NodeSmartLinkProvider */ "./src/lib/NodeSmartLinkProvider.ts");
var storage_1 = __webpack_require__(/*! ./utils/storage */ "./src/utils/storage.ts");
var validation_1 = __webpack_require__(/*! ./utils/validation */ "./src/utils/validation.ts");
var query_1 = __webpack_require__(/*! ./utils/query */ "./src/utils/query.ts");
var initialState = {
    queryTimerId: 0,
};
var defaultConfiguration = {
    languageCodename: null,
    projectId: null,
    queryParam: 'kontent-smart-link-enabled',
};
var Plugin = /** @class */ (function () {
    function Plugin(configuration) {
        var _this = this;
        this.destroy = function () {
            var _a;
            _this.unwatchQueryParams();
            _this.nodeSmartLinkProvider.destroy();
            (_a = _this.iFrameCommunicator) === null || _a === void 0 ? void 0 : _a.destroy();
        };
        this.updateConfiguration = function (configuration) {
            _this.configuration = __assign(__assign({}, _this.configuration), configuration);
        };
        this.updateState = function (state) {
            _this.state = __assign(__assign({}, _this.state), state);
        };
        this.initializeIFrameCommunication = function () {
            if (!iframe_1.isInsideIFrame() || _this.iFrameCommunicator) {
                throw new Error('Cannot initialize iframe communication while not inside the iframe.');
            }
            _this.iFrameCommunicator = new IFrameCommunicator_1.IFrameCommunicator();
            var storage = storage_1.createStorage('kontent:plugin:iframe-settings');
            var stored = storage.get();
            var highlighterEnabled = stored !== null ? stored === null || stored === void 0 ? void 0 : stored.highlighterEnabled : true;
            if (highlighterEnabled) {
                _this.nodeSmartLinkProvider.enable();
            }
            _this.iFrameCommunicator.addMessageListener(IFrameCommunicator_1.IFrameMessageType.HighlightsStatus, function (data) {
                if (!data || !_this.nodeSmartLinkProvider)
                    return;
                _this.toggleNodeSmartLinkProvider(data.enabled);
                storage.set({
                    highlighterEnabled: data.enabled,
                });
            });
            _this.iFrameCommunicator.sendMessage(IFrameCommunicator_1.IFrameMessageType.Initialized, {
                projectId: _this.configuration.projectId,
                languageCodename: _this.configuration.languageCodename,
                highlighterEnabled: highlighterEnabled,
            });
        };
        this.watchQueryParams = function () {
            if (iframe_1.isInsideIFrame()) {
                throw new Error('No need to watch query params inside the iframe.');
            }
            if (_this.state.queryTimerId) {
                clearTimeout(_this.state.queryTimerId);
            }
            var isPluginEnabled = query_1.isQueryParamPresent(_this.configuration.queryParam);
            var hasChanged = _this.nodeSmartLinkProvider.enabled !== isPluginEnabled;
            if (hasChanged) {
                _this.toggleNodeSmartLinkProvider(isPluginEnabled);
            }
            _this.updateState({
                queryTimerId: setTimeout(_this.watchQueryParams, 1000),
            });
        };
        this.unwatchQueryParams = function () {
            clearTimeout(_this.state.queryTimerId);
        };
        this.listenToHighlighterEvents = function () {
            _this.nodeSmartLinkProvider.addEventListener(NodeSmartLinkProvider_1.NodeSmartLinkProviderEventType.ElementClicked, _this.onElementClick);
        };
        this.onElementClick = function (elementClickData) {
            var data = __assign(__assign({}, elementClickData), { projectId: elementClickData.projectId || _this.configuration.projectId || undefined, languageCodename: elementClickData.languageCodename || _this.configuration.languageCodename || undefined });
            if (validation_1.validateElementClickMessageData(data)) {
                if (iframe_1.isInsideIFrame() && _this.iFrameCommunicator) {
                    _this.iFrameCommunicator.sendMessage(IFrameCommunicator_1.IFrameMessageType.ElementClicked, data);
                }
                else {
                    var link = link_1.buildElementLink(data.projectId, data.languageCodename, data.itemId, data.elementCodename);
                    window.open(link, '_blank');
                }
            }
        };
        this.toggleNodeSmartLinkProvider = function (force) {
            var shouldEnable = typeof force !== 'undefined' ? force : !_this.nodeSmartLinkProvider.enabled;
            if (shouldEnable) {
                _this.nodeSmartLinkProvider.enable();
            }
            else {
                _this.nodeSmartLinkProvider.disable();
            }
        };
        this.nodeSmartLinkProvider = new NodeSmartLinkProvider_1.NodeSmartLinkProvider();
        this.state = initialState;
        this.configuration = __assign(__assign({}, defaultConfiguration), configuration);
        if (iframe_1.isInsideIFrame()) {
            this.initializeIFrameCommunication();
        }
        else {
            this.watchQueryParams();
        }
        this.listenToHighlighterEvents();
    }
    return Plugin;
}());
var PluginWrapper = /** @class */ (function () {
    function PluginWrapper() {
    }
    PluginWrapper.initializeOnLoad = function (configuration) {
        return new Promise(function (resolve) {
            window.addEventListener('load', function () {
                resolve(PluginWrapper.initialize(configuration));
            });
        });
    };
    PluginWrapper.initialize = function (configuration) {
        if (!PluginWrapper.plugin) {
            PluginWrapper.plugin = new Plugin(configuration);
        }
        return PluginWrapper.plugin;
    };
    PluginWrapper.prototype.destroy = function () {
        var _a;
        (_a = PluginWrapper.plugin) === null || _a === void 0 ? void 0 : _a.destroy();
        PluginWrapper.plugin = null;
    };
    PluginWrapper.prototype.setConfiguration = function (configuration) {
        if (!PluginWrapper.plugin) {
            throw new Error('KontentSmartLink is not initialized or has already been destroyed.');
        }
        else {
            PluginWrapper.plugin.updateConfiguration(configuration);
        }
    };
    return PluginWrapper;
}());
exports.default = PluginWrapper;


/***/ }),

/***/ "./src/utils/dataAttributes.ts":
/*!*************************************!*\
  !*** ./src/utils/dataAttributes.ts ***!
  \*************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getDataAttributesFromEventPath = exports.dataToDatasetAttributeName = exports.DataAttribute = void 0;
exports.DataAttribute = {
    ElementCodename: 'data-kontent-element-codename',
    ItemId: 'data-kontent-item-id',
    LanguageCodename: 'data-kontent-language-codename',
    ProjectId: 'data-kontent-project-id',
};
function dataToDatasetAttributeName(dataAttributeName) {
    return dataAttributeName.replace(/^data-/, '').replace(/-./g, function (x) { return x.toUpperCase()[1]; });
}
exports.dataToDatasetAttributeName = dataToDatasetAttributeName;
function getDataAttributesFromEventPath(event) {
    var e_1, _a, e_2, _b;
    var path = event.composedPath();
    var parsed = new Map();
    try {
        for (var path_1 = __values(path), path_1_1 = path_1.next(); !path_1_1.done; path_1_1 = path_1.next()) {
            var node = path_1_1.value;
            if (!(node instanceof HTMLElement))
                continue;
            try {
                for (var _c = (e_2 = void 0, __values(Object.entries(exports.DataAttribute))), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var _e = __read(_d.value, 2), attrName = _e[1];
                    var datasetAttrName = dataToDatasetAttributeName(attrName);
                    var datasetAttr = node.dataset[datasetAttrName];
                    if (datasetAttr && !parsed.has(attrName)) {
                        parsed.set(attrName, datasetAttr);
                    }
                }
            }
            catch (e_2_1) { e_2 = { error: e_2_1 }; }
            finally {
                try {
                    if (_d && !_d.done && (_b = _c.return)) _b.call(_c);
                }
                finally { if (e_2) throw e_2.error; }
            }
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (path_1_1 && !path_1_1.done && (_a = path_1.return)) _a.call(path_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
    return parsed;
}
exports.getDataAttributesFromEventPath = getDataAttributesFromEventPath;


/***/ }),

/***/ "./src/utils/iframe.ts":
/*!*****************************!*\
  !*** ./src/utils/iframe.ts ***!
  \*****************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
exports.isInsideIFrame = void 0;
function isInsideIFrame() {
    return window.self !== window.top;
}
exports.isInsideIFrame = isInsideIFrame;


/***/ }),

/***/ "./src/utils/link.ts":
/*!***************************!*\
  !*** ./src/utils/link.ts ***!
  \***************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
exports.buildElementLink = void 0;
function buildItemLink(projectId, languageCodename, itemId) {
    return "https://app.kontent.ai/goto/edit-item/project/" + projectId + "/variant-codename/" + languageCodename + "/item/" + itemId;
}
function buildElementLink(projectId, languageCodename, itemId, elementCodename) {
    return buildItemLink(projectId, languageCodename, itemId) + "/element/" + elementCodename;
}
exports.buildElementLink = buildElementLink;


/***/ }),

/***/ "./src/utils/node.ts":
/*!***************************!*\
  !*** ./src/utils/node.ts ***!
  \***************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
exports.isNodeOverlapped = void 0;
function isNodeOverlapped(node, rect) {
    var centerX = (rect.left + rect.right) / 2;
    var centerY = (rect.top + rect.bottom) / 2;
    var topElement = document.elementFromPoint(centerX, centerY);
    return !node.isSameNode(topElement) && !node.contains(topElement);
}
exports.isNodeOverlapped = isNodeOverlapped;


/***/ }),

/***/ "./src/utils/query.ts":
/*!****************************!*\
  !*** ./src/utils/query.ts ***!
  \****************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
exports.isQueryParamPresent = void 0;
function isQueryParamPresent(queryParam) {
    var regex = new RegExp("[?&]" + queryParam + "([=&]|$)", 'i');
    return regex.test(window.location.search);
}
exports.isQueryParamPresent = isQueryParamPresent;


/***/ }),

/***/ "./src/utils/storage.ts":
/*!******************************!*\
  !*** ./src/utils/storage.ts ***!
  \******************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
exports.createStorage = void 0;
function createStorage(key) {
    return {
        get: function () {
            var value = window.localStorage.getItem(key);
            return value ? JSON.parse(value) : null;
        },
        set: function (data) {
            var json = JSON.stringify(data);
            window.localStorage.setItem(key, json);
        },
        remove: function () {
            window.localStorage.removeItem(key);
        },
    };
}
exports.createStorage = createStorage;


/***/ }),

/***/ "./src/utils/validation.ts":
/*!*********************************!*\
  !*** ./src/utils/validation.ts ***!
  \*********************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
exports.validateElementClickMessageData = void 0;
function validateElementClickMessageData(data) {
    var errors = [];
    if (!data.projectId) {
        errors.push('Warning: project ID is required to handle element click.');
    }
    if (!data.languageCodename) {
        errors.push('Warning: language codename is required to handle element click.');
    }
    if (!data.itemId) {
        errors.push('Warning: item ID is required to handle element click.');
    }
    if (!data.elementCodename) {
        errors.push('Warning: element codename is required to handle element click.');
    }
    errors.forEach(function (error) {
        console.error(error);
    });
    return errors.length === 0;
}
exports.validateElementClickMessageData = validateElementClickMessageData;


/***/ })

/******/ })["default"];
});
//# sourceMappingURL=kontent-smart-link.umd.js.map