export declare const HighlighterViewTag = "KONTENT-SMART-LINK-OVERLAY";
export declare const HighlighterElementTag = "KONTENT-SMART-LINK-ELEMENT";
export interface IRenderer {
    readonly clear: () => void;
    readonly deselectNode: (node: HTMLElement) => void;
    readonly destroy: () => void;
    readonly render: (visibleNodes: Set<HTMLElement>) => void;
    readonly selectNode: (node: HTMLElement) => void;
}
export declare class HighlightRenderer implements IRenderer {
    private highlightByNode;
    private readonly view;
    private static createView;
    constructor();
    destroy: () => void;
    selectNode: (node: HTMLElement) => void;
    deselectNode: (node: HTMLElement) => void;
    render: (nodes: Set<HTMLElement>) => void;
    clear: () => void;
    private createHighlightForNode;
}
